
angular.module('starter', ['ionic','pascalprecht.translate', 'ngIOS9UIWebViewPatch', 'ngCordova', 'starter.controllers', 'starter.services', 'starter.directives', 'starter.filters', 'pasvaz.bindonce'])

.run(function($ionicPlatform, $rootScope, $cordovaSplashscreen, $httpBackend, $state, $timeout, $translate, TubesService) {
  //localStorage.clear();
  document.addEventListener('deviceready', function () {
  //  cordova.plugins.notification.local.on("click", function (notification, state) {
  //    var d = JSON.parse(notification.data);
  //    if (d.redirect) {
  //      $state.go(d.redirect, d.redirectData);
  //    }
  //  })
  })
  $ionicPlatform.ready(function() {
    //nworker.initWebWorker();
    //$cordovaSplashscreen.hide();
    ImgCache.options.chromeQuota = 50*1024*1024;
    ImgCache.options.usePersistentCache = true;
    ImgCache.init(function(){
      ImgCache.cacheFailed = false;
      $rootScope.$broadcast('ImgCacheStarted');
    }, function(){
      ImgCache.cacheFailed = true;
      $rootScope.$broadcast('ImgCacheFailed');
    });

    if(typeof navigator.globalization !== "undefined") {
      navigator.globalization.getPreferredLanguage(function(language) {
        $translate.use((language.value).split("-")[0]).then(function(data) {
          console.log("SUCCESS -> " + data);
        }, function(error) {
          console.log("ERROR -> " + error);
        });
      }, null);
    }

    if (window.cordova && window.cordova.plugins.Keyboard) {
      cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
    }
    if (window.StatusBar) {
      StatusBar.styleDefault();
    }

    var admobid = {};
    if( /(android)/i.test(navigator.userAgent) ) { 
      admobid = { // for Android
        banner: '',
        interstitial: 'ca-app-pub-3910324178350811/4179786164'
      };
    } else if(/(ipod|iphone|ipad)/i.test(navigator.userAgent)) {
      admobid = { // for iOS
        banner: '',
        interstitial: ''
      };
    }
    window.admobid = admobid;
    var defaultOptions = {
      bgColor: 'black',
      isTesting: false
    };
    if(window.AdMob){
      console.log("started adMob");
      window.AdMob.setOptions(defaultOptions);
      window.AdMob.prepareInterstitial({adId:window.admobid.interstitial, autoShow:false});
      window.admobid.loaded = false;
      window.admobid.shown = false;
      window.admobid.ready = false;
      $timeout(function() {
        console.log("ready to show ad")
        window.admobid.ready = true;
      }, 20000);
      var loopAd = function(){
        $timeout(function() {
          console.log("ready to show ad")
          window.admobid.ready = true;
          loopAd();
        }, 180000);
      }
      loopAd();
      document.addEventListener('onAdLoaded', function(data){
        console.log("ad loaded");
        window.admobid.loaded = true;
      });
      document.addEventListener('onAdDismiss', function(data){
        console.log("ad dismissed");
        if(window.admobid.afterAd){
          window.admobid.afterAd();
        }
      });
    }
    if(window.analytics){
      console.log("started analytics");
      window.analytics.startTrackerWithId('UA-60540875-3');
    }
    
  });
})

.config(function($stateProvider, $urlRouterProvider, $sceDelegateProvider, $compileProvider, $translateProvider) {

  ImgCache.options.debug = true;
  ImgCache.options.chromeQuota = 50*1024*1024;
  $compileProvider.imgSrcSanitizationWhitelist(/^\s*(https?|file|blob|cdvfile|filesystem):|data:image\//);
  $sceDelegateProvider.resourceUrlWhitelist([
    'self',
    'https://*.amazonaws.com/**',
    'file:**',
    'filesystem:**',
    'documents:**'
  ]);
  $translateProvider.translations('en', {
    select_language: "Where are you from?",
    change_language: "Change",
    loading_tubes: "Loading best tubes for you",
    loading_country: "Loading your country",
    trend: "Trend",
    latest: "Latest",
    create_tube: "Create a tube",
    my_tubes: "My tubes",
    add_tube: "Add a tube",
    settings: "Settings",
    search_placeholder: "Type to search a tube",
    top_searches: "Top searches",
    share: "Share",
    dub: "Dub this tube",
    add_starred: "Add to starred",
    remove_starred: "Remove from starred",
    spammy: "Spammy",
    cancel: "Cancel",
    ops: "Ops",
    no_internet: "No internet connection!",
    what_is: "What is?",
    start_dub: "Start dub",
    start_speak: "Start speak!",
    next: "Next",
    share_on_facebook: "Share on Facebook",
    share_on_instagram: "Share on Instagram",
    share_on_whatsapp: "Send via Whatsapp",
    share_on_message: "Send via Message",
    share_other: "Save  your tube",
    finish: "Finish",
    share_title: "Share your tube",
    close: "close",
    re_dub: "Re dub",
    back: "Back",
    ready_tube: "Ready to tube",
    pull_refresh: "Pull down to refresh",
    pull_latest: "Pull down to get latest tubes",
    upload_from: "Uploaded from",
    last_from: "Last from",
    no_tubes: "You have no tubes",
    help: "Help",
    home: "Home",
    tubes: "Tubes",
    legal: "Legal",
    support: "Support",
    refresh_tubes:"Refresh Tubes",
    change_country: "Change your country",
    terms: "Terms of Service",
    feedback: "Feedback",
    upload_title: "Upload a new tube",
    upload_go: "Go to",
    upload_with: "With your desktop PC or MAC",
    wait:"Wait",
    share_first:"Share or save your tube first!"
  });

  $translateProvider.translations('it', {
    select_language: "Da dove vieni?",
    change_language: "Cambia",
    loading_tubes: "Stiamo caricando i migliori tubi",
    loading_country: "Stiamo trovando il tuo stato",
    trend: "Trend",
    latest: "Ultimi",
    create_tube: "Crea un tubo",
    my_tubes: "I miei tubi",
    add_tube: "Aggiungi un tubo",
    settings: "Preferenze",
    search_placeholder: "Digita per cercare un tubo",
    top_searches: "I più cercati",
    share: "Condividi",
    dub: "Doppia il tubo",
    add_starred: "Aggiungi ai preferiti",
    remove_starred: "Rimuovi dai preferiti",
    spammy: "Segnala",
    cancel: "Indietro",
    ops: "Ops",
    no_internet: "Non sei connesso ad internet!",
    what_is: "Che cos'è?",
    start_dub: "Inizia a doppiare",
    start_speak: "Parla!",
    next: "Avanti",
    share_on_facebook: "Condividi su Facebook",
    share_on_instagram: "Condividi su Instagram",
    share_on_whatsapp: "Invia con Whatsapp",
    share_on_message: "Invia come messaggio",
    share_other: "Salva il tuo tubo",
    finish: "Fine",
    share_title: "Condividi il tuo tubo",
    close: "chiudi",
    re_dub: "Ri doppia",
    back: "Indietro",
    ready_tube: "Pronto a tubare",
    pull_refresh: "Tira giù per ricaricare",
    pull_latest: "Tira giù per i nuovi tubi",
    upload_from: "Caricato da",
    last_from: "Ultimo da",
    no_tubes: "Non c'è un tubo!",
    help: "Aiuto",
    home: "Home",
    tubes: "Tubi",
    legal: "Legale",
    support: "Supporto",
    refresh_tubes:"Ricarica i tubi",
    change_country: "Cambia lo stato",
    terms: "Termini del Servizio",
    feedback: "Feedback",
    upload_title: "Carica un nuovo tubo",
    upload_go: "Vai su",
    upload_with: "Con il tuo PC o MAC",
    wait:"Aspetta",
    share_first:"Prima condividi o salva il tuo tubo!"
  });

  $translateProvider.translations('pt', {
    select_language: "De onde você è?",
    change_language: "Mudança",
    loading_tubes: "Carregando melhores vídeos para você",
    loading_country: "Carregando seu país",
    trend: "Tendência",
    latest: "Mais recente",
    create_tube: "Criar um vídeo",
    my_tubes: "Meu vídeo",
    add_tube: "Adicionar um vídeo",
    settings: "Definições",
    search_placeholder: "Escreva para pesquisar um vídeo",
    top_searches: "Mais pesquisados",
    share: "Compartir",
    dub: "Dublar este vídeo",
    add_starred: "Adicionar favoritos",
    remove_starred: "Remover favoritos",
    spammy: "Spam",
    cancel: "Cancelar",
    ops: "Ops",
    no_internet: "Sem conexão com a internet!",
    what_is: "O que è?",
    start_dub: "Começar adublar",
    start_speak: "Começar a falar",
    next: "Próximo",
    share_on_facebook: "Compartilhe no Facebook",
    share_on_instagram: "Compartilhe no Instagram",
    share_on_whatsapp: "Enviar por whatsapp",
    share_on_message: "Enviar por Mensagem",
    share_other: "Salvar o seu vídeo",
    finish: "Acabar",
    share_title: "Compartilhe o seuvídeo",
    close: "Próximo",
    re_dub: "Dublar dinovo",
    back: "Voltar",
    ready_tube: "Pronto para",
    pull_refresh: "Puxe-o para atualizar video",
    pull_latest: "Puxe-o para obter a mais recentes video",
    upload_from: "Carregado de",
    last_from: "último de",
    no_tubes: "Você não tem vídeo!",
    help: "Ajuda",
    home: "Home",
    tubes: "Video",
    legal: "Legais",
    support: "Suporte",
    refresh_tubes:"Atualizar vídeos",
    change_country: "Mudar o seu país",
    terms: "Termos de serviço",
    feedback: "Feedback",
    upload_title: "Carregar um novo vídeo",
    upload_go: " Ir",
    upload_with: "Com o seu desktop PC ou MAC",
    wait:"Esperar",
    share_first:"Compartilhe ou salve seu video primeiro"
  });
  
  $translateProvider.preferredLanguage("en");
  $translateProvider.fallbackLanguage("en");

  $stateProvider

  .state('app', {
    url: "/app",
    abstract: true,
    templateUrl: "templates/menu.html",
    controller: 'AppCtrl'
  })

  .state('app.search', {
    url: "/search",
    views: {
      'menuContent': {
        templateUrl: "templates/search.html",
        controller: 'SearchCtrl'
      }
    },
    resolve: {
      mostSearched: function(TubesService) {
        return TubesService.getMostSearched();
      }
    }
  })

  .state('app.preload', {
    url: "/preload",
    views: {
      'menuContent': {
        templateUrl: "templates/preload.html",
        controller: 'PreloadCtrl'
      }
    }
  })

  .state('app.settings', {
    url: "/settings",
    views: {
      'menuContent': {
        templateUrl: "templates/settings.html",
        controller: 'SettingsCtrl'
      }
    }
  })

  .state('app.upload', {
    url: "/upload",
    views: {
      'menuContent': {
        templateUrl: "templates/upload.html",
        controller: 'AppCtrl'
      }
    }
  })

  .state('app.legal', {
    url: "/legal",
    views: {
      'menuContent': {
        templateUrl: "templates/legal.html",
        controller: 'AppCtrl'
      }
    }
  })

  .state('app.home', {
    url: "/home",
    views: {
      'menuContent': {
        templateUrl: "templates/home.html",
        controller: 'HomeCtrl'
      }
    },
    resolve: {
      categories: function(TubesService) {
        return TubesService.getCategories();
      },
      bestTubes: function(TubesService) {
        return TubesService.getBestTubes();
      }
    }
  })

  .state('app.category', {
    url: "/category/:categoryId",
    views: {
      'menuContent': {
        templateUrl: "templates/category.html",
        controller: 'CategoryCtrl'
      }
    },
    resolve: {
      category: function($stateParams, TubesService) {
        return TubesService.getCategory($stateParams.categoryId);
      },
      categoryId: function($stateParams) {
        return $stateParams.categoryId;
      }
    }
  })

  .state('app.myTubes', {
    url: "/mytubes",
    views: {
      'menuContent': {
        templateUrl: "templates/my-tubes.html",
        controller: 'MyTubesCtrl'
      }
    },
    resolve: {
      myTubes: function($stateParams, TubesService) {
        return TubesService.getMyTubes();
      }
    }
  })

  .state('app.extTube', {
    url: "/exttube/:tubeId",
    views: {
      'menuContent': {
        templateUrl: "templates/ext-tube.html",
        controller: 'TubeCtrl'
      }
    },
    resolve: {
      tube: function(TubesService, $stateParams) {
        return TubesService.getExtTube($stateParams.tubeId);
      }
    }
  })

  .state('app.intTube', {
    url: "/inttube/:tubeId",
    views: {
      'menuContent': {
        templateUrl: "templates/tube.html",
        controller: 'TubeCtrl'
      }
    },
    resolve: {
      tube: function(TubesService, $stateParams) {
        return TubesService.getIntTube($stateParams.tubeId);
      }
    }
  })

  .state('app.tube', {
    url: "/category/:categoryId/tube/:tubeId",
    views: {
      'menuContent': {
        templateUrl: "templates/tube.html",
        controller: 'TubeCtrl'
      }
    },
    resolve: {
      tube: function($stateParams, TubesService) {
        return TubesService.getTube($stateParams.categoryId, $stateParams.tubeId);
      }
    }
  })

  .state('app.mytube', {
    url: "/category/:categoryId/mytube/:tubeId",
    views: {
      'menuContent': {
        templateUrl: "templates/mytube.html",
        controller: 'MyTubeCtrl'
      }
    }
  });
  if(!localStorage.getItem('used'))
    $urlRouterProvider.otherwise('/app/preload');
  else
    $urlRouterProvider.otherwise('/app/home');
});


var handleOpenURL = function(url) {
  console.log(url);
  window.localStorage.setItem("external_load", url);
  setTimeout(function() {
    var body = document.getElementsByTagName("body")[0];
    var mainController = angular.element(body).scope();
    mainController.reportAppLaunched(url);
  }, 0);
};

angular.module('ngIOS9UIWebViewPatch', ['ng']).config(['$provide', function($provide) {
  'use strict';

  $provide.decorator('$browser', ['$delegate', '$window', function($delegate, $window) {

    if (isIOS9UIWebView($window.navigator.userAgent)) {
      return applyIOS9Shim($delegate);
    }

    return $delegate;

    function isIOS9UIWebView(userAgent) {
      return /(iPhone|iPad|iPod).* OS 9_\d/.test(userAgent) && !/Version\/9\./.test(userAgent);
    }

    function applyIOS9Shim(browser) {
      var pendingLocationUrl = null;
      var originalUrlFn= browser.url;

      browser.url = function() {
        if (arguments.length) {
          pendingLocationUrl = arguments[0];
          return originalUrlFn.apply(browser, arguments);
        }

        return pendingLocationUrl || originalUrlFn.apply(browser, arguments);
      };

      window.addEventListener('popstate', clearPendingLocationUrl, false);
      window.addEventListener('hashchange', clearPendingLocationUrl, false);

      function clearPendingLocationUrl() {
        pendingLocationUrl = null;
      }

      return browser;
    }
  }]);
}]);
