angular.module('starter.controllers', [])

.controller('AppCtrl', function($scope, $rootScope, $state, $ionicPlatform, $rootScope, $ionicModal, $timeout, $ionicPopover, $cordovaDialogs, $cordovaToast,
                                $ionicActionSheet, $ionicHistory, $location, $filter, $cordovaMedia, $cordovaFileTransfer, $sce, $ionicPopup, TubesService, $http) {
  // Form data for the login modal
  $scope.userLanguage = JSON.parse(localStorage.getItem('userLanguage')) ? JSON.parse(localStorage.getItem('userLanguage')): {};
  $scope.starTubes = null;
  $scope.searchLoading = false;
  $scope.dubDone = false;
  $scope.isInstagram = true;

  $scope.tubeToDub = null;

  $rootScope.$on('$locationChangeStart', function(event, next, current) {
    if(current.indexOf("tube/")>-1 && $rootScope.tube && $rootScope.tube.video){
      console.log("UNLOAD");
      $rootScope.tube.video.pause();
      $rootScope.tube.video.src = '';
      $rootScope.tube.video.load();
      $rootScope.tube = null;
    }
  });

  var isIOS = function () {
    return (device && device.platform && device.platform.toLowerCase() == "ios");
  };

  $scope.isIOS = function(){
    return isIOS();
  }

  var isAndroid = function () {
    return (device && device.platform && device.platform.toLowerCase().indexOf('android') >= 0);
  };

  if(typeof window.Instagram !== 'undefined'){

    window.Instagram.isInstalled(function (err, installed) {
      if (installed) {
        $scope.isInstagram = true;
      }
    });
  }
  $scope.goHome = function(){

    $state.go("app.home");
  }

  var showAdMob = function(afterAd){
    if(window.AdMob && window.admobid.ready){
      window.AdMob.prepareInterstitial({adId:window.admobid.interstitial, autoShow:true});
      window.admobid.loaded = false;
      window.admobid.ready = false;
    }
    afterAd();
  }

  var played = {};

  $scope.highlight = function(tube){
    if(tube.highlight)
      return $sce.trustAsHtml(tube.highlight);
    else
      return "";
  }

  $scope.onTubeClick = function(tube){
    var afterAd = function(){
      TubesService.setIntTube(tube);
      $state.go("app.intTube", {"tubeId": tube.id});
    }
    showAdMob(afterAd);
  }

  $scope.barColor = "#49c9b0";

  $rootScope.$on('$locationChangeSuccess', function(event, next, current) {
    var prts = next.split('/category/');
    if(prts.length > 1){
      var categoryId = prts[1];
      TubesService.getCategory(categoryId).then(function(c){
        console.log(c);
        $scope.barColor = c.color;
      });
      
    }else if(next.indexOf("/home") > -1){
      $scope.barColor = "#49c9b0";
    }
  });


  $scope.starTube = function(tube, categoryId){
    tube.categoryId = categoryId;
    tube.star = !tube.star;
    $scope.starTubes = JSON.parse(localStorage.getItem('starTubes'));
    if(!$scope.starTubes){
      $scope.starTubes = {};
    }
    if(tube.star){
      $scope.starTubes[tube.id] = {title: tube.title, thumb: tube.thumb, smallUrl: tube.smallUrl, url: tube.url, from: tube.from, id: tube.id, categoryId: categoryId};
    }else{
      delete $scope.starTubes[tube.id];
    }
    localStorage.setItem('starTubes', JSON.stringify($scope.starTubes));
  }

  $scope.playVideo = function(evt, tube){
    var video = evt.currentTarget.querySelector("video");
    if (video.paused) {
      if(played.tube != null){
        played.video.pause();
        played.video.src = '';
        played.video.load();
        played.tube.play = false;
      }
      tube.loaded = true;
      video.play();
      video.currentTime = 0;
      played.video = video;

      played.tube = tube;
      if(ImgCache.ready){
        ImgCache.isCached(tube.smallUrl, function(path, success) {
          if (!success) {
            $scope.$apply(function(){
              tube.play = true;
              tube.loaded = false;
            })
            ImgCache.cacheFile(tube.smallUrl, function () {
              ImgCache.getCachedFileURL(tube.smallUrl, function(path, nurl) {
                tube.cacheUrl = nurl;
                $scope.$apply(function(){
                  tube.loaded = true;
                  video.src = nurl;
                  video.load();
                  video.play();
                });
              });
            });
          }else{
            ImgCache.getCachedFileURL(tube.smallUrl, function(path, nurl) {
              tube.cacheUrl = nurl;
              $scope.$apply(function(){
                tube.play = true;
                video.src = nurl;
                
                video.load();
                video.play();
                tube.loaded = false;
              });
            });
          }
        });
      }
      
    } else{
      video.src = '';
      video.load();
      tube.play = false;
    }
  }

  var change = function(tube){
    $scope.$on('$locationChangeStart', function(event) {
      if($scope.counter != null){
        $scope.cancelDub(tube, true);
      }
    });
  }

  var startRecord = function(tube){
    $scope.share = false;
    if(isIOS()){
      tube.audioSrc = "documents://tempDub.wav";
    }
    
    var strt = function(){
      tube.video.pause();
      tube.video.currentTime = 0;
      tube.video.play();
      tube.audio = new Media(tube.audioSrc);
      tube.audio.startRecord();
      console.log("start");
    };

    var gotFile = function(fileEntry) {
      console.log("gotfile");
      if(isAndroid()){
        
        var path = fileEntry.toURL();
        tube.audioSrc = path.substring(7);
      }
      fileEntry.remove(function() {
        console.log("removed");
        strt();
      }, function(){
        console.log("not removed");
        strt();
      })
    }
    
    var gotFS= function(fileSystem) {
      if(isIOS()){
        fileSystem.root.getFile("/tempDub.waw", {create: true}, gotFile);
      }else{
        fileSystem.root.getFile("tempDub.amr", {create: true}, gotFile);
      }
    }
    $scope.started = true;
    window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, gotFS);
  }
  
  $scope.share;
  $scope.goodTube = function(tube){
    tube.video.pause();
    tube.audio.pause();
    tube.saved = false;
    if(isAndroid() && !tube.saved){
      tube.saved = true;
      console.log("saved");
      window.plugins.socialsharing.share("save", $scope.shareTube.toShare, function(e){}, function(e){});
      $cordovaToast.showShortTop('Tube saved');
    }
    
    if(!tube.shared && $scope.userLanguage.id){
      $http.post('http://api.tubesmash.com/tube/shared', {tubeId: tube.id, language:$scope.userLanguage.id, type:"done"})
        .success(function(data, status, headers, config) {
          console.log("shared info sent");
          tube.shared = true;
          if(data)
            tube.shareId = data.id;
        })
        .error(function(data, status, headers, config) {
          console.log("shared info not sent"+data);
        });
    }
    $scope.completeDub(tube);
  }

  $scope.goPhotobmb = function(){
    window.open("market://details?id=com.photobmb");
  }
  $scope.closePhotobmb = function(){
    $scope.photobmbClosed = true;
    localStorage.setItem('photobmbDisplayed', photoNr);
  }

  var photoNr = 0;
  $scope.photobmbClosed = true;
  if(!localStorage.getItem('photobmbDisplayed') || (parseInt(localStorage.getItem('photobmbDisplayed')) + 1) <= 2){
    if(localStorage.getItem('photobmbDisplayed')){
      photoNr = parseInt(localStorage.getItem('photobmbDisplayed')) +1;
    }
    $scope.photobmbClosed = false;
  }
  

  
  $scope.shareTube = function(tube){
    $scope.share = true;
  }

  //peppa, fantozzi potionkin, calcio, happy, jova

  var videoProcessed = function(tube){
    $scope.$apply(function(){
      
      $timeout(function() {
        if(isAndroid())
          tube.audio.seekTo(100);
        else
          tube.audio.seekTo(0);
        tube.audio.play();
        tube.video.currentTime = 0;
        tube.video.pause();
        tube.canStart = true;
        tube.video.load();
        tube.video.play();
        if(isIOS())
          tube.video.play();
        $scope.share = true;
      }, 1000, true);
    });
    $scope.$on('$locationChangeStart', function(event) {
      if(tube.audio){
        tube.audio.pause();
        tube.audio.release();
      }
      
    });
  }

  $scope.stopRecord = function(tube){
    tube.audio.stopRecord();
    tube.audio.release();
    if(isIOS())
      tube.toShare = cordova.file.documentsDirectory + "finalVideo.mp4";
    
    console.log(tube.audioSrc);
    window.plugins.socialsharing.shareViaTwitter(tube.video.src, tube.audioSrc, null, function(tubeName){
      
      if(isAndroid()){
        tubeName = "file://" + tubeName;
        console.log("Android processed! " + tubeName);
        tube.toShare = tubeName;
      }

      if(isIOS()){
        console.log("iOS processed!");
      }

      videoProcessed(tube);
    }, function(e){
      console.log(e);
    });
  }

  $scope.started = false;
  $scope.counter = null;
  $scope.startDub = function(tube){
    $scope.dubDone = false;
    change(tube);
    if(played.tube != null){
      played.video.pause();
      played.tube.play = false;
    }
    $scope.counter = 3;
    tube.video.pause();
    tube.video.currentTime = 0;
    var wait = function(){
      $timeout(function() {
        if($scope.counter == null){
          return;
        }
        $scope.counter--;
        if($scope.counter < 0){
          //start dub
          $scope.counter == null;
          startRecord(tube);
          tube.video.addEventListener('ended', function(){
            if($scope.started){
              //success dub
              $scope.$apply(function(){
                $scope.started = false;
                $scope.dubDone = true;
                //tube.canStart = false;
              });
              $scope.myTube = tube;
              $state.go("app.mytube", {});
              $scope.cancelDub(tube, false);
              $scope.stopRecord(tube);
            }
          }, false);
        }else{
          //need more time
          wait();
        }
      }, 1000);
    }
    wait();
  }

  $scope.restartTube = function(tube){
    if(!$scope.started){
      tube.video.pause();
      tube.video.currentTime = 0;
      tube.video.play();
    }
  }

  $scope.restartMyTube = function(tube){
    if(isAndroid())
      tube.audio.seekTo(100);
    else
      tube.audio.seekTo(0);
    tube.audio.play();
    tube.video.currentTime = 0;
    tube.video.pause();
    tube.video.play();
  }

  $scope.cancelDub = function(tube, cancel){
    tube.video.pause();
    tube.video.currentTime = 0;
    tube.video.addEventListener('ended');
    tube.blob = null;
    tube.blobUrl = null;
    if(cancel){
      if(tube.audio){
        tube.audio.stopRecord();
        tube.audio.release();
        tube.audio = null;
      }
    }
    $scope.started = false;
    $scope.counter = null;
  }

  $scope.videoIn = function(evt){
    
    var video = evt.inViewTarget;
    if (video.paused) {
      //video.play();
    }
  }

  $scope.showPopover = function(tube, categoryId) {
   // Show the action sheet
    if(!tube.star){
      var hideSheet = $ionicActionSheet.show({
        buttons: [
          { text: $filter('translate')('share') },
          { text: $filter('translate')('dub') },
          { text: $filter('translate')('add_starred') },
          { text: $filter('translate')('spammy') }
        ],

        titleText: tube.title,
        cancelText: $filter('translate')('cancel'),
        cancel: function() {
            
        },
        buttonClicked: function(index) {
          if(index == 0){
            window.plugins.socialsharing.share("http://tubesmash.com/tube/"+tube.id, null, null, null);
          }

          if(index == 1){
            $scope.onTubeClick(tube);

          }else if(index == 2){
            $scope.starTube(tube, categoryId);

          }else if(index == 3){
            window.plugins.socialsharing.shareViaEmail(
              'video id:'+tube.id+' in category id:'+tube.categoryId,
              'Spammy Tube',
              ['admin@lazooo.com'],
              null,
              null,
              []
            );
          }
         return true;
        }
      });
    }else {
      var hideSheet = $ionicActionSheet.show({
        buttons: [
          { text: $filter('translate')('share') },
          { text: $filter('translate')('dub') },
          { text: $filter('translate')('remove_starred') },
          { text: $filter('translate')('spammy') }
        ],

        titleText: tube.title,
        cancelText: $filter('translate')('cancel'),
        cancel: function() {
            
        },
        buttonClicked: function(index) {
          if(index == 0){
            window.plugins.socialsharing.share("http://tubesmash.com/tube/"+tube.id, null, null, null);
          }
          
          if(index == 1){
            console.log(tube.categoryId);
            $scope.onTubeClick(tube);

          }else if(index == 2){
            $scope.starTube(tube, categoryId);

          }else if(index == 3){
            window.plugins.socialsharing.shareViaEmail(
              'video id:'+tube.id+' in category id:'+tube.categoryId,
              'Spammy Tube',
              ['admin@lazooo.com'],
              null,
              null,
              []
            );
          }
         return true;
        }
      });
    }
  };

  $scope.goUpload = function(){
    window.plugins.socialsharing.share("http://tubesmash.com/uploader", null, null, null);
  }

  $ionicModal.fromTemplateUrl('templates/login.html', {
    scope: $scope
  }).then(function(modal) {
    $scope.modal = modal;
  });

  // Triggered in the login modal to close it
  $scope.closeLogin = function() {
    $scope.modal.hide();
  };

  // Open the login modal
  $scope.shareTube;
  $scope.completeDub = function(tube) {
    $scope.shareTube = tube;
    $scope.modal.show();
  };

  $scope.sendFeedback = function(){
    console.log("feedback");
    window.plugins.socialsharing.shareViaEmail('Dear Tubesmash, In your app I wolud like...', 'My Super Feedback!',['admin@lazooo.com'],null,null,null);
  }

  $scope.whatsappShare = function(evt){
    console.log("share whatsapp");
    $scope.shareTube.saved = true;
    if(isIOS()){
      var targetRect = evt.currentTarget.getBoundingClientRect();
      targetBounds = targetRect.left + ',' + targetRect.top + ',' + targetRect.width + ',' + targetRect.height;
      window.plugins.socialsharing.setIPadPopupCoordinates(targetBounds);
      window.plugins.socialsharing.shareViaWhatsApp("Hey! Accept my challenge and reply with Tubesmash!", $scope.shareTube.toShare, null, function(e){}, function(e){$cordovaToast.showShortTop('You need Whatsapp!')});
    }else{
      window.plugins.socialsharing.share("save", $scope.shareTube.toShare, function(e){$cordovaToast.showShortBottom('Tube saved!')}, function(e){});
      window.plugins.socialsharing.shareViaWhatsApp("Hey! Accept my challenge and reply with Tubesmash!", $scope.shareTube.toShare, null, function(e){}, function(e){$cordovaToast.showShortTop('You need Whatsapp!')});
    }
    if ($scope.shareTube.shareId) {
      $http.post('http://api.tubesmash.com/tube/shared', {shareId: $scope.shareTube.shareId, language:$scope.userLanguage.id, type:"whatsapp"})
        .success(function(data, status, headers, config) {
          console.log("shared info sent");
        })
        .error(function(data, status, headers, config) {
          console.log("shared info not sent"+data);
        });
    }
  };

  $scope.shareFinish = function(evt){
    /**if(!$scope.shareTube.saved){
      $ionicPopup.alert({
         title: $filter('translate')('wait'),
         template: $filter('translate')('share_first')
       });
      $scope.shareTube.saved = true;
    }else{*/
      $ionicHistory.nextViewOptions({
        historyRoot: true,
        disableBack: true
      });
      $scope.closeLogin();
      $state.go("app.home");
    //}
  };

  $scope.instagramShare = function(evt){
    console.log("share instagram");
    $scope.shareTube.saved = true;
    function fail(e) {
      console.log("FileSystem Error");
    }

    function gotFile(fileEntry) {
      fileEntry.file(function(file) {
        
        var reader = new FileReader();
        reader.onloadend = function(e) {
          window.Instagram.share(this.result, "#tubesmash", function (err) {
            if (err) {
              console.log("not shared insta");
            } else {
              console.log("shared insta");
            }
          });
        }
        reader.readAsDataURL(file);
      })
    }
    window.resolveLocalFileSystemURL($scope.shareTube.toShare, gotFile, fail);

    if ($scope.shareTube.shareId) {
      $http.post('http://api.tubesmash.com/tube/shared', {shareId: $scope.shareTube.shareId, language:$scope.userLanguage.id, type:"instagram"})
        .success(function(data, status, headers, config) {
          console.log("shared info sent");
        })
        .error(function(data, status, headers, config) {
          console.log("shared info not sent"+data);
        });
    }
  };

  $scope.facebookShare = function(evt){
    console.log("share fb");
    $scope.shareTube.saved = true;
    if(isIOS()){
      var targetRect = evt.currentTarget.getBoundingClientRect();
      targetBounds = targetRect.left + ',' + targetRect.top + ',' + targetRect.width + ',' + targetRect.height;
      window.plugins.socialsharing.setIPadPopupCoordinates(targetBounds);
      window.plugins.socialsharing.share("Hey! Accept my challenge and reply with Tubesmash!", null, $scope.shareTube.toShare, null);
    }else{
      window.plugins.socialsharing.share("save", $scope.shareTube.toShare, function(e){$cordovaToast.showShortBottom('Tube saved!')}, function(e){});
      window.plugins.socialsharing.share("Hey! Accept my challenge and reply with Tubesmash!", null, $scope.shareTube.toShare, null);
    }
    if ($scope.shareTube.shareId) {
      $http.post('http://api.tubesmash.com/tube/shared', {shareId: $scope.shareTube.shareId, language:$scope.userLanguage.id, type:"facebook"})
        .success(function(data, status, headers, config) {
          console.log("shared info sent");
        })
        .error(function(data, status, headers, config) {
          console.log("shared info not sent"+data);
        });
    }
  };

  $scope.fbMessengerShare = function(evt){
    console.log("share fb messenger");
    $scope.shareTube.saved = true;
    if(isIOS()){
      var targetRect = evt.currentTarget.getBoundingClientRect();
      targetBounds = targetRect.left + ',' + targetRect.top + ',' + targetRect.width + ',' + targetRect.height;
      window.plugins.socialsharing.setIPadPopupCoordinates(targetBounds);
      window.plugins.socialsharing.share("Hey! Accept my challenge and reply with Tubesmash!", null, $scope.shareTube.toShare, null);
    }else{
      window.plugins.socialsharing.share("save", $scope.shareTube.toShare, function(e){$cordovaToast.showShortBottom('Tube saved!')}, function(e){});
      window.plugins.socialsharing.share("Hey! Accept my challenge and reply with Tubesmash!", null, $scope.shareTube.toShare, null);
    }
    if ($scope.shareTube.shareId) {
      $http.post('http://api.tubesmash.com/tube/shared', {shareId: $scope.shareTube.shareId, language:$scope.userLanguage.id, type:"message"})
        .success(function(data, status, headers, config) {
          console.log("shared info sent");
        })
        .error(function(data, status, headers, config) {
          console.log("shared info not sent"+data);
        });
    }
  };

  $scope.otherShare = function(evt){
    $scope.shareTube.saved = true;
    if(isIOS()){
      console.log("save ios");
      //window.plugins.socialsharing.shareViaFacebookWithPasteMessageHint($scope.shareTube.toShare);
      var targetRect = evt.currentTarget.getBoundingClientRect();
      targetBounds = targetRect.left + ',' + targetRect.top + ',' + targetRect.width + ',' + targetRect.height;
      window.plugins.socialsharing.setIPadPopupCoordinates(targetBounds);
      window.plugins.socialsharing.share("Hey! Accept my challenge and reply with Tubesmash!", null, $scope.shareTube.toShare, null);
     // $cordovaToast.showShortTop('Saved on your Camera roll');
    }else{
      window.plugins.socialsharing.share("save", $scope.shareTube.toShare, function(e){$cordovaToast.showShortBottom('Tube saved!')}, function(e){});
      $cordovaToast.showShortBottom('Tube saved!');
    }
    if ($scope.shareTube.shareId) {
      $http.post('http://api.tubesmash.com/tube/shared', {shareId: $scope.shareTube.shareId, language:$scope.userLanguage.id, type:"saved"})
        .success(function(data, status, headers, config) {
          console.log("shared info sent");
        })
        .error(function(data, status, headers, config) {
          console.log("shared info not sent"+data);
        });
    }
  };

  var alert = function(title, msg){
    $cordovaDialogs.alert(msg, title);
  }

  $scope.doLogin = function() {
    console.log('Doing login', $scope.loginData);

    $timeout(function() {
      $scope.closeLogin();
    }, 1000);
  };
})

.controller('PreloadCtrl', function($scope, $http, $ionicHistory, $timeout, $state, $rootScope, TubesService) {
  $scope.message = null;
  $scope.loader = false;
  $scope.loadingState = false;

  $scope.$on('$stateChangeSuccess', function (a,b,c) {
    if(b.url.indexOf("/preload") == 0){
      $scope.init();
    }
  });
  $scope.languages = [
    {name:'Argentina', id:'ar'},
    {name:'Australia', id:'au'},
    {name:'Österreich', id:'at'},
    {name:'বাংলাদেশ', id:'bd'},
    {name:'Беларусь', id:'by'},
    {name:'België', id:'be'},
    {name:'Brasil', id:'br'},
    {name:'България', id:'bg'},
    {name:'Canada', id:'ca'},
    {name:'République Centrafricaine', id:'cf'},
    {name:'Chile', id:'cl'},
    {name:'中國 (中華人民共和國)', id:'cn'},
    {name:'Colombia', id:'km'},
    {name:'Congo', id:'cg'},
    {name:'Costa Rica', id:'cr'},
    {name:'Cuba', id:'cu'},
    {name:'Cyprus', id:'cy'},
    {name:'Česká republika', id:'cz'},
    {name:'Danmark', id:'dk'},
    {name:'مصر', id:'eg'},
    {name:'Eesti', id:'ee'},
    {name:'España', id:'es'},
    {name:'Suomi', id:'fi'},
    {name:'France', id:'fr'},
    {name:'Ελλάδα', id:'gr'},
    {name:'Magyarország', id:'hu'},
    {name:'Ísland', id:'is'},
    {name:'India', id:'in'},
    {name:'Ireland', id:'ie'},
    {name:'Israel', id:'il'},
    {name:'Italia', id:'it'},
    {name:'Jamaica', id:'jm'},
    {name:'日本', id:'jp'},
    {name:'Latvija', id:'lv'},
    {name:'Lubnān', id:'lb'},
    {name:'ليبيا', id:'ly'},
    {name:'Lëtzebuerg', id:'lu'},
    {name:'Madagasikara', id:'mg'},
    {name:'Malaysia', id:'my'},
    {name:'México', id:'mx'},
    {name:'المغرب', id:'ma'},
    {name:'Nederland', id:'nl'},
    {name:'New Zealand', id:'nz'},
    {name:'Norge', id:'no'},
    {name:'Perú', id:'pe'},
    {name:'Pilipinas', id:'ph'},
    {name:'Polska', id:'pl'},
    {name:'Portugal', id:'pt'},
    {name:'قطر', id:'qa'},
    {name:'România', id:'ro'},
    {name:'Россия', id:'ru'},
    {name:'المملكة العربية السعودية', id:'sa'},
    {name:'Slovensko', id:'sk'},
    {name:'Slovenija', id:'si'},
    {name:'South Africa', id:'za'},
    {name:'Sverige', id:'se'},
    {name:'Suisse', id:'ch'},
    {name:'تونس', id:'tn'},
    {name:'Україна', id:'ua'},
    {name:'الإمارات العربيّة المتّحدة', id:'ae'},
    {name:'United Kingdom', id:'en'},
    {name:'United States', id:'us'},
    {name:'Other...', id:'other'}
  ];

  var goHome = function(){
    if($scope.firstUse){
      $scope.firstUse = false;
      $timeout(function() {
          $scope.loader = true;
      }, 400, true);
    }
    $state.go("app.home");
  }

  var isIOS = function () {
    return (device && device.platform && device.platform.toLowerCase() == "ios");
  }

  $scope.init = function(){
    $scope.loader = false;
    $scope.firstUse = TubesService.isFirstUse();
    $timeout(function(){
      
      if($scope.loadingState && (!$scope.$parent.userLanguage || !$scope.$parent.userLanguage.id)){
        $scope.language = $scope.languages[0];
      }else if($scope.$parent.userLanguage && $scope.$parent.userLanguage.id){
        for(var i=0, len=$scope.languages.length; i<len; i++) {
          if($scope.languages[i].id == $scope.$parent.userLanguage.id.toLowerCase()){
            $scope.language = $scope.languages[i];
          }
        }
      }
      $scope.loadingState = false;
    }, 4000, true);
    
    $ionicHistory.nextViewOptions({
      historyRoot: true,
      disableBack: true
    });
    if($scope.firstUse && !localStorage.getItem('used')){
      localStorage.setItem('used', 'true');
      $scope.loadingState = true;
      $http.post('http://api.tubesmash.com/tube/shared', {type:"installed", version:"1.4.1"})
        .success(function(data, status, headers, config) {
          console.log("installed info sent");
        })
        .error(function(data, status, headers, config) {
          console.log("installed info not sent "+status);
        });
        if(ImgCache.ready){
          ImgCache.clearCache();
        }
    }
    
    if(!$scope.$parent.userLanguage.id || $scope.$parent.userLanguage.invalid){
      localStorage.removeItem('service');
      TubesService.service = {};
      $scope.firstUse = true;
      TubesService.getCountryIndex($scope.languages).then(function(data){
        $scope.loadingState = false;
        $scope.language = $scope.languages[data];
      })
    }else{
      if(ionic.Platform.isAndroid() == false){
        TubesService.startNotifications($scope.$parent.userLanguage.id);
      }
      goHome();
    }
  }

  $scope.setLanguage = function(language){
    
    if($scope.language != null){
      console.log(language);
      $scope.loadingState = true;
      $scope.$parent.userLanguage = {id:language.id, name:language.name};
      localStorage.setItem('userLanguage', JSON.stringify(language));
      goHome();
    }else{
      $ionicPopup.alert({
         title: 'Wait!',
         template: 'Set your country first!'
       });
    }
  }
})

.controller('HomeCtrl', function($scope, $http, $ionicActionSheet, $timeout, $ionicModal, $ionicHistory, bestTubes, categories, TubesService) {
  $scope.bestTubes = bestTubes;
  $scope.categories = categories;
  $scope.latest = [];
  $scope.tabHome = true;
  $scope.latestLoading = true;

  $scope.goLatest = function() {
    $scope.tabHome = false;
    if(!$scope.latest.length){
      $scope.latestLoading = true;
      $scope.refreshTubes();
    }
  }

  $scope.goHome = function() {
    $scope.tabHome = true;
    
  }

  $scope.init = function(){
    var ext = localStorage.getItem('external_load');
    if(ext){
      localStorage.removeItem('external_load');
      var prts = ext.split('/tube/');
      if(prts.length > 1 && $scope.$parent.userLanguage.id){
        var tubeId = prts[1];
        $state.go("app.extTube", {"tubeId": tubeId});
      }
    }
  }

  $scope.showCatPopover = function(category, helpUrl) {
     // Show the action sheet
    $scope.helpUrl = helpUrl;
    var hideSheet = $ionicActionSheet.show({
      buttons: [
        { text: 'What is?' }
      ],

      titleText: category.title,
      cancelText: 'Cancel',
      cancel: function() {
          
      },
      buttonClicked: function(index) {

        if(index == 0){
          $scope.openHelp(category);
        }
        return true;
      }
    });
  }

  $ionicModal.fromTemplateUrl('templates/help.html', {
    scope: $scope
  }).then(function(modal) {
    $scope.modal = modal;
  });

  $scope.closeHelp = function() {
    $scope.modal.hide();
  };

  $scope.openHelp = function(category) {
    $scope.modal.show();
  };
  
  $scope.refreshTubes = function(){
    if($scope.tabHome){
      TubesService.invalidateService();
      TubesService.getBestTubes().then(function(data) {
        $scope.$broadcast('scroll.refreshComplete');
        $timeout(function() {
          $scope.bestTubes = data;
          TubesService.getCategories().then(function(data) {
            $scope.categories = data;
          });
        }, 500);
        
      });
    
    }else{

      TubesService.getLatest().then(function(t){
        $scope.$broadcast('scroll.refreshComplete');
        $timeout(function() {
          $scope.latestLoading = false;
          $scope.latest = t;
        }, 500);
      }, function(e){
        $scope.$broadcast('scroll.refreshComplete');
        $scope.latestLoading = false;
      });
    }
  }
})

.controller('MyTubesCtrl', function($scope, myTubes) {
  $scope.myTubes = myTubes;
})

.controller('SettingsCtrl', function($scope, $state, $ionicHistory, TubesService) {
  $scope.changeLanguage = function(){
    $scope.$parent.userLanguage.invalid = true;
    $state.go("app.preload", {}, {reload: true});
  }

  $scope.refreshTubes = function(){
    $ionicHistory.nextViewOptions({
      disableAnimate: true
    }); 
    localStorage.removeItem('service');
    TubesService.service = {};
    TubesService.getService();
    $state.go("app.preload", {}, {reload: true});
  }
})

.controller('TubeCtrl', function($scope, $rootScope, $ionicHistory, $state, tube) {
  $scope.tube = tube;
  $rootScope.tube = $scope.tube;

  $scope.goAtHome = function(){
    $ionicHistory.nextViewOptions({
      historyRoot: true,
      disableBack: true
    });
    $state.go("app.home", {});
  }
})

.controller('SearchCtrl', function($scope, $filter, $http, $q, TubesService, $timeout, $cordovaToast, $state, mostSearched) {
  $scope.isLoading = false;
  $scope.searchedTubes = [];
  $scope.mostSearched = mostSearched;
  $scope.srcValue = "";

  var oQuery;
  $scope.searchTubes = function(query){
    oQuery = query;
    var dfd = $q.defer();
    if(query.length > 0){
      $scope.isLoading = true;
      $timeout(function(){
        if(query == oQuery){
          console.log(query);
          $scope.srcValue = query;
          TubesService.searchTubes(query).then(function(data){
            dfd.resolve(data);
            $scope.searchedTubes = data;
            $scope.isLoading = false;
          }, function(){
            $scope.isLoading = false;
            dfd.resolve([]);
            $scope.searchedTubes = [];
            cordova.plugins.Keyboard.close();
            TubesService.displayWarning($filter('translate')('ops'), $filter('translate')('no_internet'));
          });
        }
      }, 1000, true);
    }else {
      $scope.isLoading = false;
      $scope.searchedTubes = [];
      dfd.resolve([]);
    }
    if(window.analytics){
      window.analytics.trackEvent('Search', 'Searched', 'Query', query);
    }
    return dfd.promise;
  }

  $scope.onTubeClick = function(tube){
    $scope.$parent.onTubeClick(tube);
    if($scope.srcValue){

      $http.post('http://api.tubesmash.com/tube/searched', {tubeId: tube.id, language:$scope.$parent.userLanguage.id})
      .success(function(data, status, headers, config) {
        console.log("search info sent ");
      })
      .error(function(data, status, headers, config) {
        console.log("search info not sent");
      });
    }
    
  }
  
})

.controller('MyTubeCtrl', function($scope, $rootScope) {
  $scope.tube = $scope.$parent.myTube;
  $rootScope.tube = $scope.tube;
  $scope.tube.canStart = false;

  
})

.controller('MainCtrl', function($scope, $state) {

  $scope.reportAppLaunched = function(ext) {
    localStorage.removeItem('external_load');
    var prts = ext.split('/tube/');
    if(prts.length > 1){
      var tubeId = prts[1];
      $state.go("app.extTube", {"tubeId": tubeId});
    }
  }
})

.controller('CategoryCtrl', function($scope, $ionicModal, category, categoryId, TubesService) {
  $scope.category = category;
  $scope.tubes = category.tubes;

  $scope.refreshTubes = function(){
    TubesService.invalidateService();
    
    TubesService.getCategory(categoryId).then(function(data) {
      $scope.category = data;
      $scope.tubes = data.tubes;
      $scope.tubes.forEach(function(t){
        t.categoryId = category.id
      });
      if(TubesService.isFailed()){
        $cordovaToast.showShortTop('Cannot update tubes');
      }
      return $scope.category;
    });
    $scope.$broadcast('scroll.refreshComplete');
  }
  $scope.tubes.forEach(function(t){
    t.categoryId = category.id
  });
  angular.extend($scope, {
      value: 0
    });
});
