angular.module('starter.directives', [])

.directive('videoContainer', function($sce, $timeout) {
    
  return {
    restrict: "E",    
    scope: {
      currentTube: '=tube',
      cache: '=cache',
      play: '=play'
    },

    link: function(scope, elem, attrs) {
      var start = function(nurl){
        scope.currentTube.bigCacheUrl = $sce.trustAsResourceUrl(nurl);
        scope.$apply(function(){
          scope.currentTube.video.src = $sce.trustAsResourceUrl(nurl);
          scope.currentTube.video.load();
          if(!scope.currentTube.canStart){
            scope.currentTube.canStart = true;
            if(scope.currentTube.video.paused && scope.play){
              scope.currentTube.video.play();
            }
          }
        });
      }

      var v;

      var onresize = function(){
        var h = window.innerHeight;
        var w = window.innerWidth;
        var vh = w * 0.75;
        h = h-100-vh;
        h = h/2;
        if(h<0){
          h = 0;
        }
        v.style.marginTop = h+"px";
      }

      window.onresize = function(event) {
          if(v){
            onresize();
          }
      };
      var video = elem.find("video")[0];
      v = elem[0].querySelector(".video-container");
      onresize();
      video.play();
      scope.currentTube.canStart = false;
      scope.currentTube.play = false;
      scope.currentTube.video = video;
      //if(!scope.currentTube.afterCache){
        var afterCache = function(path, nurl) {
          scope.currentTube.afterCache = false;
          start(nurl);
        };
        scope.currentTube.afterCache = afterCache;

        if(ImgCache.ready && scope.cache){
          ImgCache.isCached(scope.currentTube.url, function(path, success) {
            if (!success) {
              ImgCache.cacheFile(scope.currentTube.url, function () {
                ImgCache.getCachedFileURL(scope.currentTube.url, afterCache);
              });
            } else{
              ImgCache.getCachedFileURL(scope.currentTube.url, function(path, nurl) {
                start(nurl);
              });
            }
          });
        }
      //}

    }
  };
})

.directive('colorBar', function() {
    
  return {
    restrict: "E",    
    scope: {
      color: '=color'
    },

    link: function(scope, elem, attrs) {
      var bar = elem[0].querySelector('.bar');
      if(bar){
        bar = angular.element(bar);
        scope.$watch('color', function() {
          bar.css("background-color", scope.color);
          bar.css("transition", "background-color 400ms linear");
          bar.css("color", "#fff !important");
       });
      }
    }
  };
})

.directive('headerShrink', function($document) {
  var fadeAmt;

  var shrink = function(tabs, tabs_amt, subHeader, header, amt, dir) {
    ionic.requestAnimationFrame(function() { 
      // Threshold is equal to bar-height
      var threshold = 60;
      // Scrolling down
      if(dir === 1) {
        var _amt = Math.min(threshold, amt - threshold);
      } 
      // Scrolling up
      else if(dir === -1) {
        var _amt = Math.max(0, amt - threshold);
      }
      // The translation amounts should never be negative
      _amt = _amt < 0 ? 0 : _amt;
      amt = amt < 0 ? 0 : amt;
      tabs_amt = tabs_amt < 0 ? 0 : tabs_amt; 
      // Re-position the header

      // Re-position the sub-header
      subHeader.style[ionic.CSS.TRANSFORM] = 'translate3d(0,-' + amt + 'px, 0)';
      // Re-position the tabs
    });
  };

  return {
    restrict: 'A',
    link: function($scope, $element, $attr) {
      var starty = 0;
      var shrinkAmt;
      var tabs_amt;
      // Threshold is equal to bar-height + create-post height;
      var threshold = 88;
      // header
      var header = $document[0].body.querySelector('.bar-header');
      // sub-header
      var subHeader = $document[0].body.querySelector('.bar-subheader');
      var headerHeight = header.offsetHeight;
      //angular.element(subHeader).css("top", headerHeight+"px");
      var subHeaderHeight = subHeader.offsetHeight;
      // tabs
      var tabs = $document[0].body.querySelector('.tabs');
      var tabsHeight = tabs.offsetHeight;

      var prev = 0
      var delta = 0
      var dir = 1
      var prevDir = 1
      var prevShrinkAmt = 0;
      var prevTabsShrinkAmt = 0;
      
      $element.bind('scroll', function(e) {
        // if negative scrolling (eg: pull to refresh don't do anything)
        if(e.detail.scrollTop < 0)
          return false;
        // Scroll delta
        delta = e.detail.scrollTop - prev;
        // Claculate direction of scrolling
        dir = delta >= 0 ? 1 : -1;
        // Capture change of direction
        if(dir !== prevDir) 
          starty = e.detail.scrollTop;
        // If scrolling up
        if(dir === 1) {
          // Calculate shrinking amount
          shrinkAmt = headerHeight + subHeaderHeight - Math.max(0, (starty + headerHeight + subHeaderHeight) - e.detail.scrollTop);
          // Calculate shrinking for tabs
          tabs_amt = tabsHeight - Math.max(0, (starty + tabsHeight) - e.detail.scrollTop);
          // Start shrink
          shrink(tabs, tabs_amt, subHeader, header, Math.min(threshold, shrinkAmt), dir);
          // Save prev shrink amount
          prevShrinkAmt = Math.min(threshold, shrinkAmt);
          prevTabsShrinkAmt = Math.min(tabsHeight, tabs_amt);
        }
        // If scrolling down
        else {
          // Calculate expansion amount
          shrinkAmt = prevShrinkAmt - Math.min(threshold, (starty - e.detail.scrollTop));
          // Calculate shrinking for tabs
          tabs_amt = prevTabsShrinkAmt - Math.min(tabsHeight, (starty - e.detail.scrollTop));
          // Start shrink
          shrink(tabs, tabs_amt, subHeader, header, shrinkAmt, dir);
        }
        // Save prev states for comparison 
        prevDir = dir;
        prev = e.detail.scrollTop;
      });
    }
  }
})

.directive('ionSearch', function() {
    return {
        restrict: 'E',
        replace: true,
        scope: {
            getData: '&source',
            model: '=?',
            search: '=?filter'
        },
        link: function(scope, element, attrs) {
            attrs.minLength = attrs.minLength || 0;
            scope.placeholder = attrs.placeholder || '';
            scope.search = {value: ''};

            if (attrs.class)
                element.addClass(attrs.class);

            if (attrs.source) {
                scope.$watch('search.value', function (newValue, oldValue) {
                        scope.getData({str: newValue}).then(function (results) {
                            scope.model = results;
                        });
                    
                });
            }

            scope.clearSearch = function() {
                scope.search.value = '';
            };
        },
        template: '<div class="item-input-wrapper">' +
                    '<i class="icon ion-search"></i>' +
                    '<input type="search" placeholder="{{placeholder}}" ng-model="search.value">' +
                    '<i ng-if="search.value.length > 0" ng-click="clearSearch()" class="icon ion-close"></i>' +
                  '</div>'
    };
})